<?php
/* This is stuff that goes at the top of a bunch of files.. */

// start with some generic protections even though they're largely redundant
// they can save a little server load on all those generic hack attempts at least
if (isset($_REQUEST['id']) && !is_numeric($_REQUEST['id'])) die("Non-numeric id value requested: ".$_REQUEST['id']);
if (isset($_SERVER['QUERY_STRING']) && strstr($_SERVER['QUERY_STRING'], '://')) die("A URL has been detected in the query string: ". $_SERVER['QUERY_STRING']); // no reason to ever pass http://s via GET in a url, right?
if (isset($_REQUEST['TID']) && (strstr($_REQUEST['TID'], '../') || substr_count($_REQUEST['TID'], '/') > 1 || substr_count($_REQUEST['TID'], '-') > 1 )) die($_REQUEST['TID']." disallowed for security reasons: you cannot change the directory."); // prevents avatar-related hack which was being used in june '08

error_reporting(E_ALL ^ E_NOTICE);

if ($_REQUEST['dirurl'] != '') $dirurl = ''; // prevent tampering when register globals is on
if ($_REQUEST['uploadpath'] != '') $uploadpath = ''; // prevent tampering
if ($dirurl) $settings->dirurl = $dirurl; // allow config.php to set directory url
if ($uploadpath) $settings->uploadpath = $uploadpath; // allow config.php to set file path

// start timing script execution, in case we're debugging
// (don't want to wait until we know, because that will throw off the time)
$mtime = microtime(); 
$mtime = explode(" ",$mtime); 
$mtime = $mtime[1] + $mtime[0]; 
$starttime = $mtime; 

$debuginfo = ''; // we'll fill this as we go

$querycount = 0;

$version = '1.24';

$_SERVER = $_SERVER;
$_POST = $_POST;
$_GET = $_GET;
$_COOKIE = $_COOKIE;
$HTTP_REQUEST_VARS = $_REQUEST;

require 'functions.php';
require 'commonfuncs.php';
require 'config.php';
require 'classes/database.php';
require 'classes/settings.php';
require 'classes/entries.php';
require 'classes/template.php';
require 'classes/language.php';
require 'classes/member.php';
require 'classes/comments.php';

// variables that we'll use globally \\
$db = new database;
$settings = new settingsdata;

if (!$settings->admindir) $admindir = 'admin';
else $admindir = $settings->admindir;

// see if we're in debug mode
$debug = $settings->debug;
if ($settings->debug == 'no') $debug = false;
if ($settings->debug == 'yes') $debug = true;


// Include member integration file here
$custommemberdb = false;
// include custom member db file here
if (strlen($settings->integration) > 2)
{
 $thefile = 'integration/'. $settings->integration .'.php';
 include "$thefile";
}

if (isset($_POST['securityimage'])) $_POST['securityimage'] = strtolower($_POST['securityimage']); // let them pass the security image even if they're a clueless AOLer who types with capslock on

// make compatable when register_globals is off... and secure against php code input
$skip = " newpasswordquery newusergroupquery sessionquery db skipvalidation language admindir language settings pathtoconfig dirurl uploadpath metatable databasename connection ";
$elim = explode(' ', $skip);
foreach($elim as $rem) { if ($rem != '')  {  if ($_REQUEST[$rem])   {   $_REQUEST[$rem] = ''; $_GET[$rem] = ''; $_POST[$rem] = ''; if ($$rem == $_REQUEST[$rem]) $$rem = ''; } } } // protects when reg_globals on without uglifying when off
$magicquotes = get_magic_quotes_gpc(); // prepare to sanitize for those without magic quotes
while(list($key, $value) = each($_COOKIE)) 
{ // blank out cookies to prevent 12432 votes on link on submission and the like
 $cookievarslist[] = $key;
 if (!strstr($skip, " $key ")) { $newvalue = stripcode($value); if (!$magicquotes && !is_array($_COOKIE[$key])) $newvalue = addslashes($newvalue); $_COOKIE[$key] = $newvalue;  $$key = ''; } 
} 
if ($_COOKIE['returnto'] != '') $returnto = $_COOKIE['returnto'];
while(list($key, $value) = each($_GET)) 
{
 $getvarslist[] = $key;
 if (!strstr($skip, " $key ")) { $newvalue = stripcode($value); if (!$magicquotes && !is_array($_GET[$key])) $newvalue = addslashes($newvalue); $$key = $newvalue; $_GET[$key] = $newvalue; } 
} 
while(list($key, $value) = each($_POST)) 
{
 $postvarslist[] = $key;
 if (!strstr($skip, " $key "))  { $newvalue = stripcode($value); if (!$magicquotes && !is_array($_POST[$key])) $newvalue = addslashes($newvalue); $$key = $newvalue; $_POST[$key] = $newvalue; } 
 if (strstr($key, 'rating') && ($key != 'rating')) $customratings .= ','. $key;
 $varslist .= '|||'. $key .'|||'; 
} 
while(list($key, $value) = each($_REQUEST)) 
{
 if (!strstr($skip, " $key "))  { $newvalue = stripcode($value); if (!$magicquotes && !is_array($_REQUEST[$key])) $newvalue = addslashes($newvalue); $$key = $newvalue; $_REQUEST[$key] = $newvalue; } 
 if (strstr($key, 'rating') && ($key != 'rating')) $customratings .= ','. $key;
} 
if ((isset($perpage) && !is_numeric($perpage)) ||  (isset($id) && !is_numeric($id)) || (isset($catid) && !is_numeric($catid))) dienicely("A value being set isn't numeric when it should be.");
if ($returnto == '') $returnto = 'index.php';

$thismember = new member('dummy', 'dummy');
if ($languagegroup == '') $languagegroup = $thismember->language;
if ($languagegroup == '') $languagegroup = $_COOKIE['guest_language'];
if ($languagegroup == '') $languagegroup = $settings->defaultlang;
$language = new language($languagegroup);

$templatesdir = 'templates/default';
$linkfields = $settings->linkfields;
$categoryfields = $settings->categoryfields;

if (!$templatesdir) echo "<p><font size=6><b>There seems to be a problem with your database. Most likely, you've forgotten to run the <a href=setup.php>setup script</a>.</b></font></p>";

$ipbanarray = explode("\n", $settings->bannedips);
$num = sizeof($ipbanarray);
$visitor = $_SERVER['REMOTE_ADDR'];
if ($visitor == '') $visitor = 'unreadable';
for ($i=0; $i<$num; $i++)
{
 $ipbanarray[$i] = trim($ipbanarray[$i]);	
 if ($ipbanarray[$i] != '')
 {
  if (strstr($visitor, $ipbanarray[$i]))
  {
   $template = new template("blank");
   $template->text = $language->banned;
  } 
 }
}

$header = fileread("$templatesdir/header.tpl"); // get header
$footer = fileread("$templatesdir/footer.tpl"); // get footer

// check cookie to see if this is the admin
$isadmin = false;
if ($thismember->isadmin()) $isadmin = true;

if ($action == 'settemplatesdir')
{ // if directory works, save it in cookie
  if ($header)
  {
   if ($thismember->usergroup > 1) { $thismember->template = $templatesdir; $thismember->update('template'); }
   else setcookie("guesttemplatesdir", "$templatesdir", time() + 8000000);
  }
}

if ($action == 'setlanguage')
{ // if directory works, save it in cookie
  if ($header)
  {
   if ($thismember->usergroup > 1) { $thismember->language = $languagegroup; $thismember->update('language'); }
   else setcookie("guest_language", "$languagegroup", time() + 8000000);
  }
}

if ($action == 'logout')
{
 $thismember->logout();
 if (!$template) $template = new template("$templatesdir/blank.tpl");
 $template->text = $language->loggedout;
 $loggedout = true; 
}

if ($action == 'login')
{
 $area = $language->title_login;
 if (($filled) && ($thismember->login()))
 {
  header("Location: $admindir/index.php?loggedin=1"); 
 }
 else
 {
  $template = new template("$templatesdir/admin/password.tpl");
 }
}

if ($action == 'userlogin')
{
 if ($filled)
 {
  if (!$template) $template = new template("$templatesdir/redirect.tpl");
  if ($thismember->login())
  {
   // you're logged in
   $template->replace('{MESSAGE}', $language->login_worked);
   $template->replace('{DESTINATION}', 'index.php');
  }
  else
  {
   // wrong username or password
   $template->replace('{MESSAGE}', $language->login_failed);
   $template->replace('{DESTINATION}', 'index.php?action=userlogin');
  }
 }
 else
 {
  $template = new template("$templatesdir/login.tpl");
 }
}

if ($action == 'userlogout')
{
 $thismember->logout();
 if (!$template) $template = new template("$templatesdir/redirect.tpl");
 $template->replace ('{MESSAGE}', $language->loggedout);
 $template->replace('{DESTINATION}', $returnto);
}

if ($action == 'lostpw')
{
 if ($email == '') $email = 'nothing here';
 $query = $db->select('id', 'memberstable', "email='$email'", '', '');
 $theirid = $db->rowitem($query);
 if (!$theirid)
 {
  if (!$template) $template = new template("$templatesdir/redirect.tpl");
  $template->replace('{DESTINATION}', 'index.php?action=userlogin');
  $template->replace('{MESSAGE}', $language->passwordreset_failed);
 }
 else
 {
  $ourmember = new member('id', $theirid);
  $adminaddress = $settings->email;
  $newpassword = md5(time());
  $encoded = md5($newpassword);
  $ourmember->password = $encoded;
  $ourmember->update('email,password');
  $subject = memberreplacements($language->email_passwordresetsubject, $ourmember);
  $message = str_replace('{NEWPASSWORD}', $newpassword, $language->email_passwordresetbody);
  $message = memberreplacements($message, $ourmember);
  mail("$email", "$subject", "$message", "From: $adminaddress");
  if (!$template) $template = new template("$templatesdir/redirect.tpl");
  $template->replace('{DESTINATION}', 'index.php');
  $template->replace('{MESSAGE}', $language->passwordreset_worked);
 }
}

if ($custom == 'yes') // custom templates
{ // access with index.php?custom=yes&TID=name&ext=ext
 if ($ext == '') $ext = 'tpl';
 $thefile = $TID .'.'. $ext;
 $thefile = $templatesdir .'/' . $thefile;
 $template = new template($thefile);
 // custom templates can use global variables, like the toplists, but any extra variables for custom templates go below this line, in the form $template->replace('{TEMPLATEVAR}', 'replacement');
 /* can use custom template for anything, such as custom category templates just by adding &custom=yes&TID=name to the URL */
}


?>